	.TEXT
	.GLOBAL     _start
    .GLOBAL     start_vector

@----------------------------------------------------------------------------------------@
@                                 GBA ROM FILE HEADER                                    @
@----------------------------------------------------------------------------------------@
	.ALIGN
	.CODE 32
_start:
	@ jump code
	b		rom_header_end

	@ Nintendo Logo Character Data (8000004h)
	.fill	156,1,0
	
	@ Game Title (80000A0h)
	.byte	0x00,0x00,0x00,0x00,0x00,0x00
	.byte	0x00,0x00,0x00,0x00,0x00,0x00

	@ Game Code (80000ACh)
	.byte	0x00,0x00,0x00,0x00

    @ Maker Code (80000B0h)
	.byte	0x30,0x31

    @ Fixed Value (80000B2h)
	.byte	0x96

    @ Main Unit Code (80000B3h)
	.byte	0x00

    @ Device Type (80000B4h)
	.byte	0x00

    @ Unused Data (7Byte) (80000B5h)
	.byte	0x00,0x00,0x00,0x00,0x00,0x00,0x00

    @ Software Version No (80000BCh)
	.byte	0x00

    @ Complement Check (80000BDh)
	.byte	0xf0

    @ Checksum (80000BEh)
	.byte	0x00,0x00


@----------------------------------------------------------------------------------------@
@                            INIT SECTION BEFORE REAL CODE                               @
@----------------------------------------------------------------------------------------@
	.ALIGN
	.ARM 

rom_header_end:
	b		start_vector

	.GLOBAL	__boot_method, __slave_number
__boot_method:
	.byte   0       @ boot method (0=ROM boot, 3=Multiplay boot)
__slave_number:
	.byte   0       @ slave # (1=slave#1, 2=slave#2, 3=slave#3)


@----------------------------------------------------------------------------------------@
@                                     REAL INIT CODE                                     @
@----------------------------------------------------------------------------------------@
    .ALIGN
    .ARM
start_vector:
	@
	@ set stack address for IRQ & Supervisor mode
	@
	mov		r0, #0x12			@ switch to IRQ mode
	msr		cpsr_c, r0
	ldr		sp, =__sp_irq		@ set sp_irq

	mov		r0, #0xd3			@ switch to Supervisor mode & disable all interrupts
	msr		cpsr_c, r0
	ldr		sp, =__sp_svc		@ set sp_svc

	@
	@ Welcome to Chobits OS WORLD!!! :)
	@
	mov		r0, #0				@ argc
	mov		r1, #0				@ argv
	ldr		r3, =start_vector	@ return address
	mov		lr, r3
	ldr		r3, =main
	bx		r3

    .END
